Attribute VB_Name = "modKanjiCodeConvert"
'*********************************************************************************************
'*                            R[hϊW[ For VB6/VBA                           *
'*********************************************************************************************
'
'[@\/]
'̃W[Shift-JIS/EUC/JIS/Unicode(UTF-8,UTF-16)̑ݕϊs܂B
'܂ƂĕR[hʊ֐()pӂ܂B
'ʂeXg͂܂ϊꂽeƂۏ؂͂ł܂B
'
'[g]
'ϊf[^oCg^̔zString^ϐɓǂݏoĂ
'    KCConvert( oCgz, ϊR[h, ϊ敶R[h )
'ƂČĂяoOKłD
'R[h̔sƂ
'    KCDetectCode( oCgz )
'Ƃ܂D
'ȂG[Ƃ́CG[ԍɒ萔KC_ERROR_INVALIDZbg܂D
'֐ĂяoOɃG[gbvĂB
'
'[쌠]
'̃W[̒쌠͕ێ܂ρAĔzzARɂgB
'̃W[gpĂȂ\tg̒쌠ÃW[ς̂
'쌠͂Ȃɂ܂BĔzz]ڂ̂Ƃ̓[ňꌾAƂꂵłB
'
'[Ɛӎ]
'̃W[̎gpɂ邢Ȃ鑹Qɑ΂ĂӔC𕉂܂B
'
'[̑]
'ϊASYɊԈႢ܂A҂܂łm点B
'
'[XV]
'Version 1.00   2003/10/08  ꉞ
'        1.20   2003/11/01  OUTƂԈTOgĂ̂Œ
'        1.30   2004/03/05  
'        1.50   2005/03/03  UTF-8UnicodeԂ̕ϊ֐AUTF-8̐`FbN֐
'        2.00   2008/07/13  KCConvert֐Ɉ{
'                           EUCShift-JISԂ̕ϊ𒼐ڍsCJISEUCԂ̕ϊ֐폜
'                           UTF-16BE,UTF-16LEɑΉ
'                           VBAœmF
'                           EUC̃VOVtg3ɑΉ
'                           ʊ֐
'
'                                   ==========================================================
'                                    330k http://www.330k.info/
'                                   ==========================================================
Option Explicit

'R[h킷񋓌^
Public Enum KCCode
    KC_UNKNOWN = 0              's
    KC_SHIFTJIS = 10            'Shift-JIS
    KC_JIS = 20                 'JIS
    KC_EUC = 30                 'EUC-JP
    KC_UTF8N = 80               'UTF-8N
    KC_UTF8BOM = 81             'UTF-8(BOM)
    KC_UNICODESTRING = 160      'VBString^,UCS2(UTF-16LE,BOMȂ,TQ[gyAΉ)
    KC_UTF16LE = 161            'UTF-16LE
    KC_UTF16BE = 162            'UTF-16BE
End Enum

'G[R[h
Public Const KC_ERROR_INVALID As Long = 65000

'JIS̃GXP[vV[PX
Private Const bytJISESC As Byte = &H1B      'JISESC(GXP[vV[PX)
Private Const bytKANJI1 As Byte = &H24      'JISIN1oCg"$"
Private Const bytKANJI2OLD As Byte = &H40   'JISIN2oCg(JIS)"@"
Private Const bytKANJI2NEW As Byte = &H42   'JISIN2oCg(VJIS)"B"
Private Const bytROME1 As Byte = &H28       'JIS[}IN1oCg"("
Private Const bytROME2 As Byte = &H4A       'JIS[}IN2oCg"J"
Private Const bytKATA1 As Byte = &H28       'JISpJ^JiIN1oCg"("
Private Const bytKATA2 As Byte = &H49       'JISpJ^JiIN2oCg"I"

'EUC̃GXP[vV[PX
Private Const bytSS2 As Byte = &H8E         'Single Shift 2
Private Const bytSS3 As Byte = &H8F         'Single Shift 3

'UTF-8BOM
Private Const bytUTF8BOM1 As Byte = &HEF
Private Const bytUTF8BOM2 As Byte = &HBB
Private Const bytUTF8BOM3 As Byte = &HBF

'UTF-16BOM
Private Const bytUTF16BOM1 As Byte = &HFE
Private Const bytUTF16BOM2 As Byte = &HFF

'ϊɓŎgptO
Private Enum EncodeMode
    mKanji = 1
    mRome = 2
    mKata = 3
End Enum

Public Function KCConvert(ByRef bytSource() As Byte, ByVal kcFrom As KCCode, ByVal kcTo As KCCode) As Byte()
    '*****************************************************************************************
    'w肵R[hɕϊ
    '-----------------------------------------------------------------------------------------
    '[  ]   bytSource()             ϊ̕񂪓Byte^z
    '           kcFrom                  ϊ̕R[h(񋓌^KCCode)
    '           kcTo                    ϊ̕R[h(񋓌^KCCode)
    '[߂l]   ϊꂽ񂪊i[ꂽByte^z
    '-----------------------------------------------------------------------------------------
    
    '[ϊ]
    '    JIS          Shift-JIS    EUC
    '                       
    '                       
    '   UTF-16LE       UTF-16N     UTF-16BE
    '                       
    '                       
    '   UTF-8BOM       UTF-8N
    
    Dim bytResult() As Byte     'ϊꂽi[Byte^z
    Dim i As Long               'JE^
    
    'ϊƕϊ悪R[hϊȂ
    If kcFrom = kcTo Then
        KCConvert = bytSource
        Exit Function
    End If
    
    'ϊ񂪋̂Ƃ͒Eo
    If UBound(bytSource) < 0 Then
        KCConvert = bytSource
        Exit Function
    End If
    
    'ϊ悪KC_UNKNOWNϊȂ
    If kcTo = KC_UNKNOWN Then
        KCConvert = bytSource
        Exit Function
    End If
    
    'ϊKC_UNKNOWN玩F
    If kcFrom = KC_UNKNOWN Then
        kcFrom = KCDetectCode(bytSource)
        'FłȂΒEo
        If kcFrom = KC_UNKNOWN Then
            Exit Function
        End If
    End If
    
    'ϊĂ
    Select Case kcFrom
    Case KC_SHIFTJIS
        'ϊɏ]ď
        Select Case kcTo
        Case KC_JIS
            bytResult = KCConvertShiftJISIntoJIS(bytSource)
        Case KC_EUC
            bytResult = KCConvertShiftJISIntoEUC(bytSource)
        Case Else
            'UTF-16NɕϊĂ炻̐
            bytResult = StrConv(bytSource, vbUnicode)
            bytResult = KCConvert(bytResult, KC_UNICODESTRING, kcTo)
        End Select
    
    Case KC_JIS
        'ShiftJISɕϊĂ炻̐
        bytResult = KCConvertJISIntoShiftJIS(bytSource)
        bytResult = KCConvert(bytResult, KC_SHIFTJIS, kcTo)
    
    Case KC_EUC
        'ShiftJISɕϊĂ炻̐
        bytResult = KCConvertEUCIntoShiftJIS(bytSource)
        bytResult = KCConvert(bytResult, KC_SHIFTJIS, kcTo)
    
    Case KC_UTF8N
        'ϊɏ]ď
        Select Case kcTo
        Case KC_UTF8BOM
            'BOMt
            ReDim bytResult(UBound(bytSource) + 3) As Byte
            bytResult(0) = bytUTF8BOM1
            bytResult(1) = bytUTF8BOM2
            bytResult(2) = bytUTF8BOM3
            For i = 3 To UBound(bytResult)
                bytResult(i) = bytSource(i - 3)
            Next
        Case Else
            'UTF-16NɕϊĂ炻̐
            bytResult = KCConvertUTF8IntoUnicode(bytSource)
            bytResult = KCConvert(bytResult, KC_UNICODESTRING, kcTo)
        End Select
        
    Case KC_UTF8BOM
        'BOM폜UTF-8NɂĂ炻̐
        If bytSource(0) = &HEF And bytSource(1) = &HBB And bytSource(2) = &HBF Then
            ReDim bytResult(UBound(bytSource) - 3) As Byte
            For i = 0 To UBound(bytResult)
                bytResult(i) = bytSource(i + 3)
            Next
            bytResult = KCConvert(bytResult, KC_UTF8N, kcTo)
        Else
            Err.Raise KC_ERROR_INVALID
        End If
    
    Case KC_UNICODESTRING
        'ϊɏ]ď
        Select Case kcTo
        Case KC_UTF8BOM
            bytResult = KCConvertUnicodeIntoUTF8(bytSource)
            bytResult = KCConvert(bytResult, KC_UTF8N, KC_UTF8BOM)
        Case KC_UTF8N
            bytResult = KCConvertUnicodeIntoUTF8(bytSource)
        Case KC_UTF16LE
            'BOMt
            ReDim bytResult(UBound(bytSource) + 2) As Byte
            bytResult(0) = bytUTF16BOM2
            bytResult(1) = bytUTF16BOM1
            For i = 2 To UBound(bytResult)
                bytResult(i) = bytSource(i - 2)
            Next
        Case KC_UTF16BE
            'BOMtăoCgI[_t
            ReDim bytResult(UBound(bytSource) + 2) As Byte
            bytResult(0) = bytUTF16BOM1
            bytResult(1) = bytUTF16BOM2
            For i = 2 To UBound(bytResult) Step 2
                bytResult(i) = bytSource(i - 1)
                bytResult(i + 1) = bytSource(i - 2)
            Next
        Case Else
            'Shift-JISɕϊĂ炻̐
            bytResult = StrConv(bytSource, vbFromUnicode)
            bytResult = KCConvert(bytResult, KC_SHIFTJIS, kcTo)
        End Select
        
    Case KC_UTF16LE
        'BOM폜UTF-16NɂĂ炻̐
        If bytSource(0) = bytUTF16BOM2 And bytSource(1) = bytUTF16BOM1 Then
            ReDim bytResult(UBound(bytSource) - 2) As Byte
            For i = 0 To UBound(bytResult)
                bytResult(i) = bytSource(i + 2)
            Next
            bytResult = KCConvert(bytResult, KC_UNICODESTRING, kcTo)
        Else
            Err.Raise KC_ERROR_INVALID
        End If
    
    Case KC_UTF16BE
        'BOM폜ăoCgI[_tɂCUTF-16NɂĂ炻̐
        If bytSource(0) = bytUTF16BOM1 And bytSource(1) = bytUTF16BOM2 Then
            ReDim bytResult(UBound(bytSource) - 2) As Byte
            For i = 0 To UBound(bytResult) Step 2
                bytResult(i) = bytSource(i + 3)
                bytResult(i + 1) = bytSource(i + 2)
            Next
            bytResult = KCConvert(bytResult, KC_UNICODESTRING, kcTo)
        Else
            Err.Raise KC_ERROR_INVALID
        End If
    
    Case Else
        'Ăяos
        Err.Raise KC_ERROR_INVALID
    End Select
    
    KCConvert = bytResult
    
End Function

Private Function KCConvertShiftJISIntoJIS(ByRef bytSource() As Byte) As Byte()
    '*****************************************************************************************
    'Shift-JISJISɕϊ(֐)
    '-----------------------------------------------------------------------------------------
    '[  ]   bytSource()             ϊShift-JIS񂪓Byte^z
    '[߂l]   ϊꂽ񂪊i[ꂽByte^z
    '-----------------------------------------------------------------------------------------
    
    Dim bytResult() As Byte     'ϊꂽi[Byte^z
    Dim emMode As EncodeMode    '[}J^JĩtO
    Dim i As Long               'JE^
    Dim j As Long               'JE^
    
    ReDim bytResult(UBound(bytSource) * 5) As Byte     '傫߂ɗpӂĂ
    
    'ϐ̏
    i = 0
    j = 0
    emMode = mRome
    
    'ϊ
    Do While i <= UBound(bytSource())
        If (bytSource(i) >= &H80& And bytSource(i) <= &HA0) Or (bytSource(i) >= &HE0) Then
            '擪rbgĂāApJï̗ɂȂƂ
            'Sp
            If Not emMode = mKanji Then
                '܂őSpłȂƂJISIN
                bytResult(j) = bytJISESC
                bytResult(j + 1) = bytKANJI1
                bytResult(j + 2) = bytKANJI2NEW
                
                'JE^i߂
                j = j + 3
            End If
            
            'Û܂ܑ
            bytResult(j) = bytSource(i)
            bytResult(j + 1) = bytSource(i + 1)
            
            'ϊ
            If bytResult(j) >= &HE0& Then
                bytResult(j) = bytResult(j) - &H40&
            End If
            If bytResult(j + 1) >= &H80& Then
                bytResult(j + 1) = bytResult(j + 1) - 1
            End If
            If bytResult(j + 1) >= &H9E& Then
                bytResult(j) = (bytResult(j) - &H70) * 2
                bytResult(j + 1) = bytResult(j + 1) - &H7D
            Else
                bytResult(j) = (bytResult(j) - &H70) * 2 - 1
                bytResult(j + 1) = bytResult(j + 1) - &H1F
                
            End If
            
            'łtO𗧂Ă
            emMode = mKanji
            
            'JE^i߂
            i = i + 2
            j = j + 2
        ElseIf bytSource(i) >= &HA1 And bytSource(i) <= &HDF Then
            'pJ^Ji
            
            If Not emMode = mKata Then
                'JISJ^JiIN
                bytResult(j) = bytJISESC
                bytResult(j + 1) = bytKATA1
                bytResult(j + 2) = bytKATA2
                
                'JE^i߂
                j = j + 3
            End If
            
            'gbvrbg낷
            bytResult(j) = bytSource(i) - &H80
            
            'J^JiłtO𗧂Ă
            emMode = mKata
            
            i = i + 1
            j = j + 1
            
        Else
            'ANSI
            
            If Not emMode = mRome Then
                'JIS[}IN
                bytResult(j) = bytJISESC
                bytResult(j + 1) = bytROME1
                bytResult(j + 2) = bytROME2
                
                'JE^i߂
                j = j + 3
            End If
            
            '̂܂
            bytResult(j) = bytSource(i)
            
            '[}łtO𗧂Ă
            emMode = mRome
            
            i = i + 1
            j = j + 1
        End If
    Loop
    
    'IOɂ͕K[}ɖ߂
    If Not emMode = mRome Then
        'JIS[}IN
        bytResult(j) = bytJISESC
        bytResult(j + 1) = bytROME1
        bytResult(j + 2) = bytROME2
        
        'JE^i߂
        j = j + 3
    End If
    
    'bytResultKvȕo
    ReDim Preserve bytResult(j - 1) As Byte
    
    '߂lɑ
    KCConvertShiftJISIntoJIS = bytResult()
    
End Function

Private Function KCConvertJISIntoShiftJIS(ByRef bytSource() As Byte) As Byte()
    '*****************************************************************************************
    'JISShift-JISɕϊ(֐)
    '-----------------------------------------------------------------------------------------
    '[  ]   bytSource()             ϊJIS񂪓Byte^z
    '[߂l]   ϊꂽ񂪊i[ꂽByte^z
    '-----------------------------------------------------------------------------------------
    'ESC ( JŔpJ^Jiɓ̂ɑΉ邽߁AtO͔pSp𕪂邾ɂĂ܂B
    
    Dim bytResult() As Byte     'ϊꂽi[Byte^z
    Dim emMode As EncodeMode    '[}J^JĩtO
    Dim i As Long               'JE^
    Dim j As Long               'JE^
    
    ReDim bytResult(UBound(bytSource) * 5) As Byte     '傫߂ɗpӂĂ
    
    'ϐ̏
    i = 0
    j = 0
    emMode = mRome
    
    'ϊ
    Do While i <= UBound(bytSource())
        If bytSource(i) = bytJISESC Then
            'ESCƂ
            If bytSource(i + 1) = bytKANJI1 And (bytSource(i + 2) = bytKANJI2OLD Or bytSource(i + 2) = bytKANJI2NEW) Then
                'INłƂ
                
                'SpłtO𗧂Ă
                emMode = mKanji
                
                'JE^i߂
                i = i + 3
                
            ElseIf bytSource(i + 1) = bytROME1 And bytSource(i + 2) = bytROME2 Then
                '[}INłƂ
                
                '[}łtO𗧂Ă
                emMode = mRome
                
                'JE^i߂
                i = i + 3
                
            ElseIf bytSource(i + 1) = bytKATA1 And bytSource(i + 2) = bytKATA2 Then
                'J^JiINłƂ
                
                'J^JiłtO𗧂Ă
                emMode = mKata
                
                'JE^i߂
                i = i + 3
                
            Else
                'ăJE^i߂(Ȃƕsȃt@C̎Ɏ~܂Ă܂)
                i = i + 1
                
            End If
            
        Else
            'ESCłȂƂ
            Select Case emMode
            Case mKanji
                'SpłƂ
                
                'Û܂ܑ
                bytResult(j) = bytSource(i)
                bytResult(j + 1) = bytSource(i + 1)
                
                'ϊ
                If (bytResult(j) Mod 2) = 1 Then
                    bytResult(j) = (bytResult(j) + 1) \ 2 + &H70
                    bytResult(j + 1) = bytResult(j + 1) + &H1F
                Else
                    bytResult(j) = bytResult(j) \ 2 + &H70
                    bytResult(j + 1) = bytResult(j + 1) + &H7D
                End If
                If bytResult(j) >= &HA0 Then
                    bytResult(j) = bytResult(j) + &H40
                End If
                If bytResult(j + 1) >= &H7F Then
                    bytResult(j + 1) = bytResult(j + 1) + &H1
                End If
                
                'JE^i߂
                i = i + 2
                j = j + 2
                
            Case mRome
                '[}łƂ
                
                '̂܂
                bytResult(j) = bytSource(i)
                
                'JE^i߂
                i = i + 1
                j = j + 1
            
            Case mKata
                'pJiłƂ
                
                'gbvrbg𗧂Ă
                bytResult(j) = bytSource(i) Or &H80
                
                'JE^i߂
                i = i + 1
                j = j + 1
                
            End Select
        End If
        
        
    Loop
    
    'bytResultKvȕo
    ReDim Preserve bytResult(j - 1) As Byte
    
    '߂lɑ
    KCConvertJISIntoShiftJIS = bytResult()
    
End Function

Private Function KCConvertEUCIntoShiftJIS(ByRef bytSource() As Byte) As Byte()
    '*****************************************************************************************
    'EUCShiftJISɕϊ(֐)
    '-----------------------------------------------------------------------------------------
    '[  ]   bytSource()             ϊEUC񂪓Byte^z
    '[߂l]   ϊꂽ񂪊i[ꂽByte^z
    '-----------------------------------------------------------------------------------------
    
    Dim bytResult() As Byte     'ϊꂽi[Byte^z
    Dim i As Long               'JE^(ϊ)
    Dim j As Long               'JE^(ϊ)
    
    ReDim bytResult(UBound(bytSource) * 2) As Byte     '傫߂ɗpӂĂ
    
    'ϐ̏
    i = 0
    j = 0
    
    'ϊ
    Do While i <= UBound(bytSource())
        
        If bytSource(i) = bytSS2 Then
            'pJi
            
            '1oCg΂
            bytResult(j) = bytSource(i + 1)
            
            'JE^i߂
            i = i + 2
            j = j + 1
            
        ElseIf bytSource(i) = bytSS3 Then
            'JIS⏕(ShiftJISł͕\s)
            
            bytResult(j) = &H3F     'Ƃ肠"?"ɒu
            
            'JE^i߂
            i = i + 3
            j = j + 1
            
        ElseIf bytSource(i) >= &H80& Then
            'ʏ̑Sp
            
            'ϊ
            bytResult(j) = bytSource(i) - &H80
            bytResult(j + 1) = bytSource(i + 1) - &H80
            If (bytResult(j) Mod 2) = 1 Then
                bytResult(j) = (bytResult(j) + 1) \ 2 + &H70
                bytResult(j + 1) = bytResult(j + 1) + &H1F
            Else
                bytResult(j) = bytResult(j) \ 2 + &H70
                bytResult(j + 1) = bytResult(j + 1) + &H7D
            End If
            If bytResult(j) >= &HA0 Then
                bytResult(j) = bytResult(j) + &H40
            End If
            If bytResult(j + 1) >= &H7F Then
                bytResult(j + 1) = bytResult(j + 1) + &H1
            End If
            
            
            'JE^i߂
            i = i + 2
            j = j + 2
        Else
            'ASCIIƔf
            
            '̂܂
            bytResult(j) = bytSource(i)
            
            i = i + 1
            j = j + 1
        End If
    Loop
    
    'bytResultKvȕo
    ReDim Preserve bytResult(j - 1) As Byte
    
    '߂lɑ
    KCConvertEUCIntoShiftJIS = bytResult()
    
End Function

Private Function KCConvertShiftJISIntoEUC(ByRef bytSource() As Byte) As Byte()
    '*****************************************************************************************
    'ShiftJISEUCɕϊ(֐)
    '-----------------------------------------------------------------------------------------
    '[  ]   bytSource()             ϊJIS񂪓Byte^z
    '[߂l]   ϊꂽ̓Byte^z
    '-----------------------------------------------------------------------------------------
    
    Dim bytResult() As Byte     'ϊꂽi[Byte^z
    Dim i As Long               'JE^(ϊ)
    Dim j As Long               'JE^(ϊ)
    
    ReDim bytResult(UBound(bytSource) * 2) As Byte     '傫߂ɗpӂĂ
    
    'ϐ̏
    i = 0
    j = 0
    
    'ϊ
    Do While i <= UBound(bytSource())
        If (bytSource(i) >= &H80& And bytSource(i) <= &HA0) Or (bytSource(i) >= &HE0) Then
            '擪rbgĂāApJï̗ɂȂƂ
            'Sp
            
            'Û܂ܑ
            bytResult(j) = bytSource(i)
            bytResult(j + 1) = bytSource(i + 1)
            
            'ϊ
            If bytResult(j) >= &HE0& Then
                bytResult(j) = bytResult(j) - &H40&
            End If
            If bytResult(j + 1) >= &H80& Then
                bytResult(j + 1) = bytResult(j + 1) - 1
            End If
            If bytResult(j + 1) >= &H9E& Then
                bytResult(j) = (bytResult(j) - &H70) * 2
                bytResult(j + 1) = bytResult(j + 1) - &H7D
            Else
                bytResult(j) = (bytResult(j) - &H70) * 2 - 1
                bytResult(j + 1) = bytResult(j + 1) - &H1F
            End If
            bytResult(j) = bytResult(j) + &H80
            bytResult(j + 1) = bytResult(j + 1) + &H80
            
            'JE^i߂
            i = i + 2
            j = j + 2
        
        ElseIf bytSource(i) >= &HA1 And bytSource(i) <= &HDF Then
            'pJ^Ji
            
            'SS2}
            bytResult(j) = bytSS2
            
            bytResult(j + 1) = bytSource(i)
            
            i = i + 1
            j = j + 2
            
        Else
            'ASCII
            
            '̂܂
            bytResult(j) = bytSource(i)
            
            i = i + 1
            j = j + 1
        End If
    Loop
    
    'bytResultKvȕo
    ReDim Preserve bytResult(j - 1) As Byte
    
    '߂lɑ
    KCConvertShiftJISIntoEUC = bytResult()
    
End Function

Private Function KCConvertUnicodeIntoUTF8(ByRef bytSource() As Byte) As Byte()
    '*****************************************************************************************
    'UnicodeUTF-8ɕϊ(֐)
    '-----------------------------------------------------------------------------------------
    '[  ]   bytSource               ϊUTF-16񂪓Byte^z
    '[߂l]   ϊꂽ񂪊i[ꂽByte^z
    '-----------------------------------------------------------------------------------------
    
    Dim bytResult() As Byte     'ϊꂽi[Byte^z
    Dim i As Long               'JE^
    Dim j As Long               'JE^
    Dim lngRet As Long
    
    ReDim bytResult(UBound(bytSource) * 5) As Byte     '傫߂ɗpӂĂ
    
    'ϐ̏
    i = 0
    j = 0
    
    For i = 0 To UBound(bytSource) Step 2
        '1Long^Ɋi[
        lngRet = CLng(bytSource(i)) + CLng(bytSource(i + 1)) * 256
        
        Select Case lngRet
        Case 0 To &H7F&
            'ASCIÎƂ
            bytResult(j) = CByte(lngRet)    '̂܂
            
            'JE^i߂
            j = j + 1
            
        Case &H80& To &H7FF&
            '2oCĝƂ
            
            '1oCg
            bytResult(j) = CByte(&HC0 Or ((lngRet And &H7C0&) \ 64))
            '2oCg
            bytResult(j + 1) = CByte(&H80 Or (lngRet And &H3F))
            
            'JE^i߂
            j = j + 2
            
        Case &H800& To &HFFFF&
            '3oCĝƂ
            
            '1oCg
            bytResult(j) = CByte(&HE0 Or ((lngRet And &HF000&) \ 4096))
            '2oCg
            bytResult(j + 1) = CByte(&H80 Or ((lngRet And &HFC0&) \ 64))
            '3oCg
            bytResult(j + 2) = CByte(&H80 Or (lngRet And &H3F))
            
            'JE^i߂
            j = j + 3
            
        End Select
    Next i
    
    'bytResultKvȕo
    ReDim Preserve bytResult(j - 1) As Byte
    
    '߂lɑ
    KCConvertUnicodeIntoUTF8 = bytResult()
    
End Function

Private Function KCConvertUTF8IntoUnicode(ByRef bytSource() As Byte) As String
    '*****************************************************************************************
    'UTF-8Unicodeɕϊ(֐)
    '-----------------------------------------------------------------------------------------
    '[  ]   bytSource               ϊUTF-8񂪓Byte^z
    '[߂l]   ϊꂽ񂪊i[ꂽString
    '-----------------------------------------------------------------------------------------
    
    Dim bytResult() As Byte     'ϊꂽi[Byte^z
    Dim i As Long               'JE^
    Dim j As Long               'JE^
    Dim lngRet As Long
    
    ReDim bytResult(UBound(bytSource) * 3) As Byte      '傫߂ɗpӂĂ
    
    'ϐ̏
    i = 0
    j = 0
    
    'ϊ
    Do While i <= UBound(bytSource())
        Select Case bytSource(i)
        Case 0 To &H7F
            'ASCIIƂ
            
            bytResult(j) = bytSource(i)
            bytResult(j + 1) = 0
            
            'JE^i߂
            i = i + 1
            j = j + 2
            
        Case &HC2 To &HDF
            '2oCg
            
            bytResult(j) = (bytSource(i) And &H3&) * 64 Or (bytSource(i + 1) And &H3F)
            bytResult(j + 1) = (bytSource(i) And &H1C) \ 4
            
            'JE^i߂
            i = i + 2
            j = j + 2
            
        Case &HE0 To &HEF
            '3oCg
        
            bytResult(j) = (bytSource(i + 1) And &H3) * 64 Or (bytSource(i + 2) And &H3F)
            bytResult(j + 1) = (bytSource(i) And &HF) * 16 Or (bytSource(i + 1) And &H3C) \ 4
            
            'JE^i߂
            i = i + 3
            j = j + 2
            
        Case &HF0 To &HF7
            '4oCg(VBUnicode(UCS-2)ł͕\s)
            
            bytResult(j) = (bytSource(i + 2) And &H3) * 64 Or (bytSource(i + 3) And &H3F)
            bytResult(j + 1) = (bytSource(i + 1) And &HF) * 16 Or (bytSource(i + 2) And &H3C) \ 4
            
            'JE^i߂
            i = i + 4
            j = j + 2
            
        Case &HF8 To &HFB
            '5oCg(VBUnicode(UCS-2)ł͕\s)
            
            bytResult(j) = (bytSource(i + 3) And &H3) * 64 Or (bytSource(i + 4) And &H3F)
            bytResult(j + 1) = (bytSource(i + 2) And &HF) * 16 Or (bytSource(i + 3) And &H3C) \ 4
            
            'JE^i߂
            i = i + 5
            j = j + 2
            
        Case &HFC To &HFD
            '6oCg(VBUnicode(UCS-2)ł͕\s)
            
            bytResult(j) = (bytSource(i + 4) And &H3) * 64 Or (bytSource(i + 5) And &H3F)
            bytResult(j + 1) = (bytSource(i + 3) And &HF) * 16 Or (bytSource(i + 4) And &H3C) \ 4
            
            'JE^i߂
            i = i + 6
            j = j + 2
            
        Case Else
            'sȕ
            Err.Raise KC_ERROR_INVALID
            
        End Select
    Loop
    
    'bytResultKvȕo
    ReDim Preserve bytResult(j - 1) As Byte
    
    '߂lɑ
    KCConvertUTF8IntoUnicode = bytResult()
    
End Function

Public Function KCDetectCode(ByRef bytSource() As Byte) As KCCode
    '*****************************************************************************************
    'R[h𔻕ʂ
    '-----------------------------------------------------------------------------------------
    '[  ]   bytSource               fR[h̕񂪊i[ꂽByte^z
    '[߂l]   fꂽR[h߂񋓌^KCCode(W[擪QƂĂ)
    '-----------------------------------------------------------------------------------------
    Dim i As Long                       'JE^
    Dim lngCountStart As Long           'JE^̍ŏ̓Y
    Dim bolIsAscii As Boolean           'ASCIIǂ̃tO
    
    'ϐ
    lngCountStart = 0
    
    'BOM`FbN
    If UBound(bytSource()) >= 3 Then
        If bytSource(0) = bytUTF8BOM1 And bytSource(1) = bytUTF8BOM2 And bytSource(2) = bytUTF8BOM3 Then
            'UTF-8BOMH
            If KCIsValidUTF8(bytSource, True) Then
                KCDetectCode = KC_UTF8BOM
                Exit Function
            End If
        End If
    End If
    If UBound(bytSource()) >= 2 Then
        If bytSource(0) = bytUTF16BOM2 And bytSource(1) = bytUTF16BOM1 Then
            'UTF-16LEH
            If UBound(bytSource()) Mod 2 = 1 Then   'oCgłȂƂmF
                KCDetectCode = KC_UTF16LE
                Exit Function
            End If
        ElseIf bytSource(0) = bytUTF16BOM1 And bytSource(1) = bytUTF16BOM2 Then
            'UTF-16BEH
            If UBound(bytSource()) Mod 2 = 1 Then   'oCgłȂƂmF
                KCDetectCode = KC_UTF16BE
                Exit Function
            End If
        End If
    End If
    
    '܂ASCIIJIS𔻕
    bolIsAscii = True
    For i = 0 To UBound(bytSource())
        If Not KCInRange(bytSource(i), &H0, &H7F) Then
            'ASCIIł͂Ȃ(JISłȂ)
            bolIsAscii = False
            Exit For
        ElseIf bytSource(i) = bytJISESC Then
            'ESCoĂĂ̂JIS̉\A
            If KCIsValidJIS(bytSource) Then
                KCDetectCode = KC_JIS
                Exit Function
            End If
        End If
    Next i
    If bolIsAscii Then
        'ASCII(}`oCggĂȂ)ƂShiftJISƂĕԂ
        KCDetectCode = KC_SHIFTJIS
        Exit Function
    End If
    
    'ShiftJIS
    If KCIsValidShiftJIS(bytSource()) Then
        KCDetectCode = KC_SHIFTJIS
        Exit Function
    End If
    
    'EUC
    If KCIsValidEUC(bytSource()) Then
        KCDetectCode = KC_EUC
        Exit Function
    End If
    
    'UTF-8N𔻒
    If KCIsValidUTF8(bytSource(), False) Then
        KCDetectCode = KC_UTF8N
        Exit Function
    End If
    
    '܂łĔʂłȂUCS2H
    If UBound(bytSource()) Mod 2 = 1 Then   'oCgłȂƂmF
        KCDetectCode = KC_UNICODESTRING
        Exit Function
    End If
    
    'ʕs\
    KCDetectCode = KC_UNKNOWN
    
End Function

Private Function KCIsValidJIS(ByRef bytSource() As Byte) As Boolean
    '*****************************************************************************************
    'JIS񂩂ǂ𔻕ʂ(֐)
    '-----------------------------------------------------------------------------------------
    '[  ]   bytSource               f镶񂪊i[ꂽByte^z
    '[߂l]   ȂTrue,sȕȂFalse
    '-----------------------------------------------------------------------------------------
    
    Dim i As Long               'JE^
    Dim emMode As EncodeMode    '[}J^JĩtO
    
    emMode = mRome
    KCIsValidJIS = False
    
    On Error GoTo Err_Handler
    
    For i = 0 To UBound(bytSource)
        If bytSource(i) = bytJISESC Then
            'ESCƂ
            If bytSource(i + 1) = bytKANJI1 And (bytSource(i + 2) = bytKANJI2OLD Or bytSource(i + 2) = bytKANJI2NEW) Then
                'INłƂ
                emMode = mKanji
                i = i + 2
            ElseIf bytSource(i + 1) = bytROME1 And bytSource(i + 2) = bytROME2 Then
                '[}INłƂ
                emMode = mRome
                i = i + 2
            ElseIf bytSource(i + 1) = bytKATA1 And bytSource(i + 2) = bytKATA2 Then
                'J^JiINłƂ
                emMode = mKata
                i = i + 2
            Else
                'ESCƂJISłƂ͔fȂ
                Exit Function
            End If
        Else
            Select Case emMode
            Case mRome
                If Not KCInRange(bytSource(i), &H0, &H7F) Then
                    's
                    Exit Function
                End If
            Case Else
                If Not KCInRange(bytSource(i), &H20, &H7F) Then
                    's
                    Exit Function
                End If
            End Select
        End If
    Next
    
    '
    KCIsValidJIS = True
    
Err_Handler:
    'G[s
    
End Function

Private Function KCIsValidShiftJIS(ByRef bytSource() As Byte) As Boolean
    '*****************************************************************************************
    'ShiftJIS񂩂ǂ𔻕ʂ(֐)
    '-----------------------------------------------------------------------------------------
    '[  ]   bytSource               f镶񂪊i[ꂽByte^z
    '[߂l]   ȂTrue,sȕȂFalse
    '-----------------------------------------------------------------------------------------
    Dim i As Long               'JE^
    
    KCIsValidShiftJIS = False
    
    On Error GoTo Err_Handler
    
    For i = 0 To UBound(bytSource)
        If KCInRange(bytSource(i), &H81, &H9F) Or KCInRange(bytSource(i), &HE0, &HFC) Then
            'Sp
            If Not (KCInRange(bytSource(i + 1), &H40, &H7E) Or KCInRange(bytSource(i + 1), &H80, &HFC)) Then
                's
                Exit Function
            End If
            i = i + 1
        ElseIf Not (KCInRange(bytSource(i), &HA1, &HDF) Or KCInRange(bytSource(i), &H0, &H7F)) Then
            'ASCII┼pJiłȂΕs
            Exit Function
        End If
    Next i
    
    'ł
    KCIsValidShiftJIS = True
    
Err_Handler:
    'G[s
    
End Function

Private Function KCIsValidEUC(ByRef bytSource() As Byte) As Boolean
    '*****************************************************************************************
    'EUC񂩂ǂ𔻕ʂ(֐)
    '-----------------------------------------------------------------------------------------
    '[  ]   bytSource               f镶񂪊i[ꂽByte^z
    '[߂l]   ȂTrue,sȕȂFalse
    '-----------------------------------------------------------------------------------------
    Dim i As Long               'JE^
    
    KCIsValidEUC = False
    
    On Error GoTo Err_Handler
    
    For i = 0 To UBound(bytSource)
        If bytSource(i) = bytSS2 Then
            If Not KCInRange(bytSource(i + 1), &HA1, &HDF) Then
                's
                Exit Function
            End If
            i = i + 1
        ElseIf bytSource(i) = bytSS3 Then
            If Not (KCInRange(bytSource(i + 1), &HA1, &HFE) And KCInRange(bytSource(i + 2), &HA1, &HFE)) Then
                's
                Exit Function
            End If
            i = i + 2
        ElseIf KCInRange(bytSource(i), &HA1, &HFE) Then
            If Not KCInRange(bytSource(i + 1), &HA1, &HFE) Then
                's
                Exit Function
            End If
            i = i + 1
        ElseIf Not KCInRange(bytSource(i), &H0, &H7F) Then
            's
            Exit Function
        End If
    Next i
    
    'ł
    KCIsValidEUC = True
    
Err_Handler:
    'G[s
    
End Function

Private Function KCIsValidUTF8(ByRef bytSource() As Byte, ByVal bolBOM As Boolean) As Boolean
    '*****************************************************************************************
    'UTF-8񂩂ǂ𔻕ʂ(֐)
    '-----------------------------------------------------------------------------------------
    '[  ]   bytSource               f镶񂪊i[ꂽByte^z
    '           bolBOM                  BOMȂTrue,ȂȂFalse
    '[߂l]   ȂTrue,sȕȂFalse
    '-----------------------------------------------------------------------------------------
    
    Dim i As Long               'JE^
    
    KCIsValidUTF8 = False
    
    On Error GoTo Err_Handler
    
    For i = 0 To UBound(bytSource)
        If KCInRange(bytSource(i), &H0, &H7F) Then
        ElseIf KCInRange(bytSource(i), &HC2, &HDF) And _
                KCInRange(bytSource(i + 1), &H80, &HBF) Then
            i = i + 1
        ElseIf KCInRange(bytSource(i), &HE0, &HE0) And _
                KCInRange(bytSource(i + 1), &HA0, &HBF) And _
                KCInRange(bytSource(i + 2), &H80, &HBF) Then
            i = i + 2
        ElseIf KCInRange(bytSource(i), &HE1, &HEC) And _
                KCInRange(bytSource(i + 1), &H80, &HBF) And _
                KCInRange(bytSource(i + 2), &H80, &HBF) Then
            i = i + 2
        ElseIf KCInRange(bytSource(i), &HED, &HED) And _
                KCInRange(bytSource(i + 1), &H80, &H9F) And _
                KCInRange(bytSource(i + 2), &H80, &HBF) Then
            i = i + 2
        ElseIf KCInRange(bytSource(i), &HEE, &HEF) And _
                KCInRange(bytSource(i + 1), &H80, &HBF) And _
                KCInRange(bytSource(i + 2), &H80, &HBF) Then
            i = i + 2
        ElseIf KCInRange(bytSource(i), &HF0, &HF0) And _
                KCInRange(bytSource(i + 1), &H90, &HBF) And _
                KCInRange(bytSource(i + 2), &H80, &HBF) And _
                KCInRange(bytSource(i + 3), &H80, &HBF) Then
            i = i + 3
        ElseIf KCInRange(bytSource(i), &HF1, &HF3) And _
                KCInRange(bytSource(i + 1), &H80, &HBF) And _
                KCInRange(bytSource(i + 2), &H80, &HBF) And _
                KCInRange(bytSource(i + 3), &H80, &HBF) Then
            i = i + 3
        ElseIf KCInRange(bytSource(i), &HF4, &HF4) And _
                KCInRange(bytSource(i + 1), &H80, &H8F) And _
                KCInRange(bytSource(i + 2), &H80, &HBF) And _
                KCInRange(bytSource(i + 3), &H80, &HBF) Then
            i = i + 3
        Else
            'sȕ
            Exit Function
        End If
        
    Next i
    
    'ł
    KCIsValidUTF8 = True
    
Err_Handler:
    'G[s
    
End Function

Private Function KCInRange(ByVal lngTarget As Long, ByVal lngLowerBound As Long, ByVal lngUpperBound As Long) As Boolean
    '*****************************************************************************************
    '͈͓ɓĂ邩肷(֐)
    '-----------------------------------------------------------------------------------------
    '[  ]   lngTarget               肳鐔l
    '           lngLowerBound           
    '           lngUpperBound           
    '[߂l]   ͈͓ȂTrue,͈͊OȂFalse
    '-----------------------------------------------------------------------------------------

    KCInRange = (lngTarget >= lngLowerBound) And (lngTarget <= lngUpperBound)
End Function
